/*****************************************************************************
 *- Utility Function Declarations (Non-Exported) ----------------------------*
 *****************************************************************************/

#include <visa.h>

#define RSSFD_NAN                 9.91e+37
#define RSSFD_NAN_VI_INT32        0x80000000

ViStatus rssfd_InitAttributes (ViSession vi);
ViStatus rssfd_DefaultInstrSetup (ViSession openInstrSession);
ViStatus rssfd_CheckStatus (ViSession vi);
ViStatus rssfd_WaitForOPC (ViSession vi, ViUInt32 maxTime);
ViInt32 rssfd_StringIndex(ViString array[], ViChar buff[]); 
ViBoolean rssfd_invalidViInt32Range (ViInt32 val, ViInt32 min, ViInt32 max);
ViBoolean rssfd_invalidViUInt32Range (ViUInt32 val, ViUInt32 min, ViUInt32 max);
ViBoolean rssfd_invalidViReal64Range (ViReal64 val, ViReal64 min, ViReal64 max);
ViBoolean rssfd_invalidViBooleanRange (ViBoolean val);
ViStatus rssfd_SetOPCTimeout(ViSession   instrSession, ViInt32 timeout);
ViStatus rssfd_GetOPCTimeout(ViSession   instrSession, ViInt32 *timeout);
ViStatus rssfd_CheckBeforeRead (ViSession instrSession, ViUInt32 maxTime);
void rssfd_SWAP_32(unsigned char *data, long points);  
ViStatus rssfd_dataReadTrace (ViSession instrSession,
                                 ViInt32 window,
                                 ViString resultsType, 
                                 ViInt32 arrayLength, 
                                 /*@out@*/ViReal64 _VI_FAR traceData[],
                                 ViPInt32 noofPoints);
ViStatus rssfd_readDataBlock (ViSession instrSession,
                                  /*@out@*/ViChar **outputBuffer, /*@out@*/ViUInt32 *byteCount);
ViStatus rssfd_GetAttributeRepCapName (ViSession instrSession,
                                ViUInt32 attributeID,
                                ViString repCapNameId,
                                ViInt32 value,
                                ViInt32 bufferSize,
                                ViChar _VI_FAR repCapName[]);
ViStatus rssfd_ParseLimitLineCatalog(ViChar *buffer, ViInt32 size, ViChar *catalogList, ViInt32 *nbValues);
ViStatus rssfd_ClearBeforeRead (ViSession instrSession);
ViStatus rssfd_ParseCatalog(ViChar *buffer, ViInt32 size, ViChar *catalogList, ViInt32 *nbValues);
ViStatus _VI_FUNC rssfd_dataReadTraceIQ (ViSession   instrSession,
                                            ViInt32     bufferSize,
                                            ViPInt32    noofPoints,
                                            /*@out@*/ViReal64 _VI_FAR realPartsI[],
                                            /*@out@*/ViReal64 _VI_FAR imaginaryPartsQ[]);
ViStatus rssfd_dataReadTraceOnly (ViSession instrSession,
                                  ViInt32 arrayLength, 
                                  /*@out@*/ViReal64 _VI_FAR traceData[],
                                  ViPInt32 noofPoints);
